#ifdef THINK_C
     #include "::ShowInitAndName.h"
#else
     #include "ShowInitAndName.h"
#endif

/* IMPORTANT: Read "ShowInitAndName.h" first!! */



#ifdef powerc
ProcInfoType __procinfo = kThinkCStackBased;
#endif

void main ( void );
void WaitFor ( long howLongToWaitInSixtiethsOfASecond );
void AppendCStringToCStringWithLimit ( char *destinationCStringPtr, char *sourceCStringPtr, unsigned long limit );

#define kExampleErrorMessagesSTRResourceID          128
#define kExampleErrorMessagesCouldntGetFilename       1
#define kExampleErrorMessagesNumberOfRandomMessages   4


void main ( void )
{
     /*****************************************************/
     /*                                                   */
     /* YOU DONT HAVE TO DO ALL OF THIS TO SHOW AN INIT! */
     /*                                                   */
     /* There are a bunch of variations in this example.  */
     /* See the SIMPLE example for ordinary usage.        */ 
     /*                                                   */
     /*****************************************************/
     
     /* This code: 1) Gets the current filename for an init,                     
                   2) Displays many example inits             */
                  
     /* 96/01/11   v1.0.0   David Cook   First version  */ 
     
     
          
     short exampleErrorMessageStringIndex; /* This will be the index to the example error message we display from the 'STR#' resource */
    
     unsigned long secs; /* We use this instead of a Random() number - since Random requires initialization of a graf port */
    
     Str255 tempPascalString;
     char tempCString [ 255 + 1 ];
     
     char extensionNameInCFormat [ 255 + 1 ]; /* This is the c-format filename of the init */
     
     FCBPBRec hGetVolRecord; /* This is used to find out the current filename of the init */     
     
     
     
     /* Before we display our examples, lets find out what the filename of this init is. */
               
     hGetVolRecord.ioCompletion = nil;
     hGetVolRecord.ioFCBIndx = 0;
     hGetVolRecord.ioVRefNum = 0;
     hGetVolRecord.ioRefNum = CurResFile ( );
     tempPascalString [ 0 ] = 0;
     hGetVolRecord.ioNamePtr = (StringPtr) tempPascalString;
     
     if ( PBGetFCBInfo ( &hGetVolRecord, false ) != noErr )
     {
          CopyCStringFromPascalStringWithLimit ( extensionNameInCFormat, "\pThe Loch Ness Extension", 255 );
          
          /* Let the user know we couldnt come up with our real filename. */
          exampleErrorMessageStringIndex = kExampleErrorMessagesCouldntGetFilename;
     }
     else
     {
          CopyCStringFromPascalStringWithLimit ( extensionNameInCFormat, tempPascalString, 255 );
          /* Weve got our real filename, so lets display a funny message chosen at random */
          
          GetDateTime ( &secs );
          exampleErrorMessageStringIndex = kExampleErrorMessagesCouldntGetFilename + 1 + ( secs % kExampleErrorMessagesNumberOfRandomMessages );
          /* Were using GetDateTime because the real Random() function only works when Quickdraw is active */
     }     
     
     
     
     
/**************/
/*            */
/* EXAMPLE #1 */
/*            */
/**************/

     /* Now were actually going to display some init icons and names */
     
     
     /* The Loch Ness Extension */
     /* This example shows the most common way to show an init. */
     
       
     ShowInitAndName ( 135, extensionNameInCFormat, nil, noErr, false ); /* Show the icon and init name and hilite the name (like it is selected) */  
     WaitFor ( 90 ); /* Pretend to do actual init work here */
     ShowInitAndName ( 135, extensionNameInCFormat, nil, noErr, true ); /* Show the icon and init name again, but dont hilite the name. and then move over for the next init */         





     
     WaitFor ( 15 ); /* Fake pause between inits */
     
     
     
     
     
/**************/
/*            */
/* EXAMPLE #2 */
/*            */
/**************/  
     
     /* CICNs */
     /* In this example were actually using 'cicn's rather than 'icl8's. (The only way you
        can tell is by looking at the resources with ResEdit; the routine call isnt significant.)
        We could have used 'cicn's in the previous two examples, as you dont have to do anything different
        to show 'cicn's. The routines automatically check
        for either 'cicn's or 'icl8's with the specified resource id. */
        
     /* Also, just to be different, were passing a pascal format string "\p"; */
     /* which means we need to call ShowInitAndPascalName */
        

     ShowInitAndPascalName ( 128, "\pICL8 or CICN", nil, noErr, false );
     WaitFor ( 90 ); /* Pretend to do actual init work here */
     ShowInitAndPascalName ( 128, "\pICL8 or CICN", nil, noErr, true );       
     
    
    
    
    
    
     WaitFor ( 15 ); /* Fake pause between inits */
     
     
     
     
    
          
/**************/
/*            */
/* EXAMPLE #3 */
/*            */
/**************/     
     
     /* No Bosses */
     /* This example shows the most common way to show an init that fails. */
     
     /* Were going to load an error message here, so that it will be displayed to
        the user. If you don't want to display an error message, simply pass nil
        for the third parameter. */
     GetIndString ( tempPascalString, kExampleErrorMessagesSTRResourceID, exampleErrorMessageStringIndex ); /* Get the message */
     CopyCStringFromPascalStringWithLimit ( tempCString, tempPascalString, 255 ); /* Convert it to c-format */
     AppendCStringToCStringWithLimit ( extensionNameInCFormat, "\015\015", 255 ); /* Add a couple of line feeds the extension name */
     AppendCStringToCStringWithLimit ( extensionNameInCFormat, tempCString, 255 ); /* Add the message after the extension name and linefeeds */



     /* Show the icon and init name and hilite the name (like it is selected) */
          
     ShowInitAndName ( 133, "No Bosses", nil, noErr, false ); /* Show the icon and init name and hilite the name (like it is selected) */  
     WaitFor ( 90 ); /* Pretend to do actual init work here */
     ShowInitAndName ( 134, "No Bosses", extensionNameInCFormat, nilHandleErr /* <-- whatever */, true ); /* ANY error number indicates the icon should be crossed out */         
      
     
     
     
     
     
     
     
     WaitFor ( 15 ); /* Fake pause between inits */
     
     
     
     
     
     

/**************/
/*            */
/* EXAMPLE #4 */
/*            */
/**************/       
     
     
     /* Animated Skier - SKeys */
     
     /* You can animate an icon just by passing a different resource id to ShowInitAndName. */
     
         
     ShowInitAndName ( 129, "SKeys", nil, noErr, false );
     
     WaitFor ( 35 ); /* Pretend to do some actual init work here */
     
     ShowInitAndName ( 130, nil, nil, noErr, false );

     WaitFor ( 35 ); /* Pretend to do some actual init work here */

     ShowInitAndName ( 131, nil, nil, noErr, false );

     WaitFor ( 35 ); /* Pretend to do some actual init work here */

     ShowInitAndName ( 132, "...ouch", nil, noErr, true );
                        
     
     
     
     
     
     WaitFor ( 15 ); /* Fake pause between inits */
     
     
     
     
    
     
/**************/
/*            */
/* EXAMPLE #5 */
/*            */
/**************/       
 
     /* Storm Impact, Inc. */
     
     
     ShowInitAndName ( 137, "Storm Impact, Inc.", nil, noErr, true );
     /* Show the icon and init name without ever highlighting - just to show you it could be done. */         
}









void WaitFor ( long howLongToWaitInSixtiethsOfASecond )
{
     /* This causes a pause during startup - to simulate an init installing itself. */
     /* You dont need this routine in your actual init.                            */

     /* 96/01/11   v1.0.0   David Cook   First version  */ 

     long timeToFly;
     
          
     timeToFly = TickCount ( ) + howLongToWaitInSixtiethsOfASecond;
     
     while ( timeToFly > TickCount ( ) )
     {
     };
}



void AppendCStringToCStringWithLimit ( char *destinationCStringPtr, char *sourceCStringPtr, unsigned long limit )
{
     /* This copies a c-formatted string to the end of another c-formatted string.  */
     /* If the total length of the two strings exceeds "limit", only the characters */
     /* within limit are appended.                                                  */
     
     /*  01.00  95/01/12  D. Cook   Initial Definition */


     if ( limit > 0 && destinationCStringPtr != nil && sourceCStringPtr != nil )
     {
          while ( limit > 0 && *destinationCStringPtr != 0 )
          {
               limit--;
               
               destinationCStringPtr++;
          }
          
          
          while ( limit > 0 && *sourceCStringPtr != 0 )
          {
               limit--;
               
               *destinationCStringPtr = *sourceCStringPtr;
               destinationCStringPtr++;
               sourceCStringPtr++;
          }
          
          *destinationCStringPtr = 0;
     }
}
